package space.eptaproject.vmodaddon.mixins;

import edn.stratodonut.trackwork.tracks.forces.SimpleWheelController;
import org.joml.Math;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.Shadow;
import space.eptaproject.vmodaddon.Config;
import space.eptaproject.vmodaddon.ISimpleWheelController;

@Mixin(SimpleWheelController.class)
public abstract class SimpleWheelControllerMixin implements ISimpleWheelController {
    @Shadow private volatile float suspensionStiffness;

    @Overwrite(remap = false)
    public final float setDamperCoefficient(float delta) {
        this.suspensionStiffness = Math.clamp(1, Config.Suspension_Stiffness_LIMIT.get(), this.suspensionStiffness + delta);
        return this.suspensionStiffness;
    }
}
